Index: palm/trunk/SOURCE/netcdf_interface_mod.f90
===================================================================
--- palm/trunk/SOURCE/netcdf_interface_mod.f90	(revision 4742)
+++ palm/trunk/SOURCE/netcdf_interface_mod.f90	(revision 4792)
@@ -1,20 +1,19 @@
 !> @file netcdf_interface_mod.f90
-!------------------------------------------------------------------------------!
+!--------------------------------------------------------------------------------------------------!
 ! This file is part of the PALM model system.
 !
-! PALM is free software: you can redistribute it and/or modify it under the
-! terms of the GNU General Public License as published by the Free Software
-! Foundation, either version 3 of the License, or (at your option) any later
-! version.
-!
-! PALM is distributed in the hope that it will be useful, but WITHOUT ANY
-! WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
-! A PARTICULAR PURPOSE.  See the GNU General Public License for more details.
-!
-! You should have received a copy of the GNU General Public License along with
-! PALM. If not, see <http://www.gnu.org/licenses/>.
+! PALM is free software: you can redistribute it and/or modify it under the terms of the GNU General
+! Public License as published by the Free Software Foundation, either version 3 of the License, or
+! (at your option) any later version.
+!
+! PALM is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the
+! implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
+! Public License for more details.
+!
+! You should have received a copy of the GNU General Public License along with PALM. If not, see
+! <http://www.gnu.org/licenses/>.
 !
 ! Copyright 1997-2020 Leibniz Universitaet Hannover
-!------------------------------------------------------------------------------!
+!--------------------------------------------------------------------------------------------------!
 !
 ! Current revisions:
@@ -25,40 +24,42 @@
 ! -----------------
 ! $Id$
+! file re-formatted to follow the PALM coding standard
+!
+! 4742 2020-10-14 15:11:02Z schwenkel
 ! Implement snow and graupel (bulk microphysics)
-! 
+!
 ! 4502 2020-04-17 16:14:16Z schwenkel
 ! Implementation of ice microphysics
-! 
+!
 ! 4455 2020-03-11 12:20:29Z Giersch
 ! Axis attribute added to netcdf output
-! 
+!
 ! 4400 2020-02-10 20:32:41Z suehring
-! Move routine to transform coordinates from netcdf_interface_mod to 
+! Move routine to transform coordinates from netcdf_interface_mod to
 ! basic_constants_and_equations_mod
-! 
+!
 ! 4360 2020-01-07 11:25:50Z suehring
 ! Adjusted output of multi-agent system for biometeorology
-! 
+!
 ! 4227 2019-09-10 18:04:34Z gronemeier
 ! Replace function date_time_string by call to get_date_time
-! 
+!
 ! 4223 2019-09-10 09:20:47Z gronemeier
-! replaced rotation angle from input-netCDF file
-! by namelist parameter 'rotation_angle'
-! 
+! replaced rotation angle from input-netCDF file by namelist parameter 'rotation_angle'
+!
 ! 4182 2019-08-22 15:20:23Z scharf
 ! Corrected "Former revisions" section
-! 
+!
 ! 4127 2019-07-30 14:47:10Z suehring
-! -Introduce new vertical dimension for plant-canopy output. 
-! -Temporarlily disable masked output for soil (merge from branch resler)
-! 
+! - Introduce new vertical dimension for plant-canopy output.
+! - Temporarlily disable masked output for soil (merge from branch resler)
+!
 ! 4069 2019-07-01 14:05:51Z Giersch
-! Masked output running index mid has been introduced as a local variable to 
-! avoid runtime error (Loop variable has been modified) in time_integration
-! 
+! Masked output running index mid has been introduced as a local variable to avoid runtime error
+! (Loop variable has been modified) in time_integration
+!
 ! 4046 2019-06-21 17:32:04Z knoop
 ! removal of special treatment for usm_define_netcdf_grid call
-! 
+!
 ! 4039 2019-06-18 10:32:41Z suehring
 ! Rename subroutines in module for diagnostic quantities
@@ -71,6 +72,6 @@
 !
 ! 3994 2019-05-22 18:08:09Z suehring
-! remove origin time from time unit, compose origin_time_string within
-! subroutine netcdf_create_global_atts
+! remove origin time from time unit, compose origin_time_string within subroutine
+! netcdf_create_global_atts
 !
 ! 3954 2019-05-06 12:49:42Z gronemeier
@@ -78,6 +79,6 @@
 !
 ! 3953 2019-05-06 12:11:55Z gronemeier
-! bugfix: set origin_time and starting point of time coordinate according to
-!         day_of_year_init and time_utc_init
+! bugfix: set origin_time and starting point of time coordinate according to day_of_year_init and
+!         time_utc_init
 !
 ! 3942 2019-04-30 13:08:30Z kanani
@@ -92,6 +93,6 @@
 !
 ! 3744 2019-02-15 18:38:58Z suehring
-! Bugfix: - initialize return values to ensure they are set before returning
-!           (routine define_geo_coordinates)
+! Bugfix: - initialize return values to ensure they are set before returning (routine
+!           define_geo_coordinates)
 !         - change order of dimensions for some variables
 !
@@ -103,6 +104,5 @@
 !
 ! 3655 2019-01-07 16:51:22Z knoop
-! Move the control parameter "salsa" from salsa_mod to control_parameters
-! (M. Kurppa)
+! Move the control parameter "salsa" from salsa_mod to control_parameters (M. Kurppa)
 !
 ! Revision 1.1  2005/05/18 15:37:16  raasch
@@ -113,126 +113,132 @@
 ! ------------
 !> In case of extend = .FALSE.:
-!> Define all necessary dimensions, axes and variables for the different
-!> netCDF datasets. This subroutine is called from check_open after a new
-!> dataset is created. It leaves the open netCDF files ready to write.
+!> Define all necessary dimensions, axes and variables for the different netCDF datasets. This
+!> subroutine is called from check_open after a new dataset is created. It leaves the open netCDF
+!> files ready to write.
 !>
 !> In case of extend = .TRUE.:
-!> Find out if dimensions and variables of an existing file match the values
-!> of the actual run. If so, get all necessary information (ids, etc.) from
-!> this file.
+!> Find out if dimensions and variables of an existing file match the values of the actual run. If
+!> so, get all necessary information (ids, etc.) from this file.
 !>
-!> Parameter av can assume values 0 (non-averaged data) and 1 (time averaged
-!> data)
+!> Parameter av can assume values 0 (non-averaged data) and 1 (time averaged data)
 !>
-!> @todo calculation of output time levels for parallel NetCDF still does not
-!>       cover every exception (change of dt_do, end_time in restart)
-!> @todo timeseries and profile output still needs to be rewritten to allow
-!>       modularization
+!> @todo calculation of output time levels for parallel NetCDF still does not cover every exception
+!        (change of dt_do, end_time in restart)
+!> @todo timeseries and profile output still needs to be rewritten to allow modularization
 !> @todo output 2d UTM coordinates without global arrays
 !> @todo output longitude/latitude also with non-parallel output (3d and xy)
-!------------------------------------------------------------------------------!
+!--------------------------------------------------------------------------------------------------!
  MODULE netcdf_interface
 
-    USE control_parameters,                                                    &
-        ONLY:  biometeorology, fl_max,                                         &
-               max_masks, multi_agent_system_end,                              &
-               multi_agent_system_start,                                       &
-               rotation_angle,                                                 &
-               var_fl_max, varnamelength
+    USE control_parameters,                                                                        &
+        ONLY:  biometeorology,                                                                     &
+               fl_max,                                                                             &
+               max_masks,                                                                          &
+               multi_agent_system_end,                                                             &
+               multi_agent_system_start,                                                           &
+               rotation_angle,                                                                     &
+               var_fl_max,                                                                         &
+               varnamelength
     USE kinds
 #if defined( __netcdf )
     USE NETCDF
 #endif
-    USE mas_global_attributes,                                                 &
+    USE mas_global_attributes,                                                                     &
         ONLY:  dim_size_agtnum
 
-    USE netcdf_data_input_mod,                                                 &
-        ONLY: coord_ref_sys,                                                   &
-              crs_list,                                                        &
+    USE netcdf_data_input_mod,                                                                     &
+        ONLY: coord_ref_sys,                                                                       &
+              crs_list,                                                                            &
               init_model
 
     PRIVATE
 
-    CHARACTER (LEN=16), DIMENSION(13) ::  agt_var_names =                      &
-          (/ 'ag_id           ', 'ag_x            ', 'ag_y            ',       &
-             'ag_wind         ', 'ag_temp         ', 'ag_group        ',       &
-             'ag_iPT          ', 'ag_PM10         ', 'ag_PM25         ',       &
-             'not_used        ', 'not_used        ', 'not_used        ',       &
-             'not_used        ' /)
-
-    CHARACTER (LEN=16), DIMENSION(13) ::  agt_var_units = &
-          (/ 'dim_less        ', 'meters          ', 'meters          ',       &
-             'm/s             ', 'K               ', 'dim_less        ',       &
-             'C               ', 'tbd             ', 'tbd             ',       &
-             'tbd             ', 'not_used        ', 'not_used        ',       &
-             'not_used        ' /)
-
     INTEGER(iwp), PARAMETER ::  dopr_norm_num = 7, dopts_num = 29, dots_max = 100
-
-    CHARACTER (LEN=7), DIMENSION(dopr_norm_num) ::  dopr_norm_names =          &
-         (/ 'wtheta0', 'ws2    ', 'tsw2   ', 'ws3    ', 'ws2tsw ', 'wstsw2 ',  &
-            'z_i    ' /)
-
-    CHARACTER (LEN=7), DIMENSION(dopr_norm_num) ::  dopr_norm_longnames =      &
-         (/ 'wtheta0', 'w*2    ', 't*w2   ', 'w*3    ', 'w*2t*w ', 'w*t*w2 ',  &
-            'z_i    ' /)
-
-    CHARACTER (LEN=7), DIMENSION(dopts_num) :: dopts_label =                   &
-          (/ 'tnpt   ', 'x_     ', 'y_     ', 'z_     ', 'z_abs  ', 'u      ', &
-             'v      ', 'w      ', 'u"     ', 'v"     ', 'w"     ', 'npt_up ', &
-             'w_up   ', 'w_down ', 'radius ', 'r_min  ', 'r_max  ', 'npt_max', &
-             'npt_min', 'x*2    ', 'y*2    ', 'z*2    ', 'u*2    ', 'v*2    ', &
-             'w*2    ', 'u"2    ', 'v"2    ', 'w"2    ', 'npt*2  ' /)
-
-    CHARACTER (LEN=7), DIMENSION(dopts_num) :: dopts_unit =                    &
-          (/ 'number ', 'm      ', 'm      ', 'm      ', 'm      ', 'm/s    ', &
-             'm/s    ', 'm/s    ', 'm/s    ', 'm/s    ', 'm/s    ', 'number ', &
-             'm/s    ', 'm/s    ', 'm      ', 'm      ', 'm      ', 'number ', &
-             'number ', 'm2     ', 'm2     ', 'm2     ', 'm2/s2  ', 'm2/s2  ', &
-             'm2/s2  ', 'm2/s2  ', 'm2/s2  ', 'm2/s2  ', 'number2' /)
-
     INTEGER(iwp) ::  dots_num  = 25  !< number of timeseries defined by default
     INTEGER(iwp) ::  dots_soil = 26  !< starting index for soil-timeseries
     INTEGER(iwp) ::  dots_rad  = 32  !< starting index for radiation-timeseries
 
-    CHARACTER (LEN=13), DIMENSION(dots_max) :: dots_label =                    &
-          (/ 'E            ', 'E*           ', 'dt           ',                &
-             'us*          ', 'th*          ', 'umax         ',                &
-             'vmax         ', 'wmax         ', 'div_new      ',                &
-             'div_old      ', 'zi_wtheta    ', 'zi_theta     ',                &
-             'w*           ', 'w"theta"0    ', 'w"theta"     ',                &
-             'wtheta       ', 'theta(0)     ', 'theta(z_mo)  ',                &
-             'w"u"0        ', 'w"v"0        ', 'w"q"0        ',                &
-             'ol           ', 'q*           ', 'w"s"         ',                &
-             's*           ', 'ghf          ', 'qsws_liq     ',                &
-             'qsws_soil    ', 'qsws_veg     ', 'r_a          ',                &
-             'r_s          ',                                                  &
-             'rad_net      ', 'rad_lw_in    ', 'rad_lw_out   ',                &
-             'rad_sw_in    ', 'rad_sw_out   ', 'rrtm_aldif   ',                &
-             'rrtm_aldir   ', 'rrtm_asdif   ', 'rrtm_asdir   ',                &
+    CHARACTER (LEN=16) :: heatflux_output_unit       !< unit for heatflux output
+    CHARACTER (LEN=16) :: waterflux_output_unit      !< unit for waterflux output
+    CHARACTER (LEN=16) :: momentumflux_output_unit   !< unit for momentumflux output
+    CHARACTER (LEN=40) :: netcdf_data_format_string
+
+    CHARACTER (LEN=16), DIMENSION(13) ::  agt_var_names =                                          &
+          (/ 'ag_id           ', 'ag_x            ', 'ag_y            ',                           &
+             'ag_wind         ', 'ag_temp         ', 'ag_group        ',                           &
+             'ag_iPT          ', 'ag_PM10         ', 'ag_PM25         ',                           &
+             'not_used        ', 'not_used        ', 'not_used        ',                           &
+             'not_used        ' /)
+
+    CHARACTER (LEN=16), DIMENSION(13) ::  agt_var_units =                                          &
+          (/ 'dim_less        ', 'meters          ', 'meters          ',                           &
+             'm/s             ', 'K               ', 'dim_less        ',                           &
+             'C               ', 'tbd             ', 'tbd             ',                           &
+             'tbd             ', 'not_used        ', 'not_used        ',                           &
+             'not_used        ' /)
+
+    CHARACTER (LEN=20), DIMENSION(fl_max)            :: dofl_dim_label_x
+    CHARACTER (LEN=20), DIMENSION(fl_max)            :: dofl_dim_label_y
+    CHARACTER (LEN=20), DIMENSION(fl_max)            :: dofl_dim_label_z
+    CHARACTER (LEN=20), DIMENSION(fl_max*var_fl_max) :: dofl_label
+    CHARACTER (LEN=20), DIMENSION(fl_max*var_fl_max) :: dofl_unit
+
+    CHARACTER (LEN=7), DIMENSION(dopr_norm_num) ::  dopr_norm_names =                              &
+         (/ 'wtheta0', 'ws2    ', 'tsw2   ', 'ws3    ', 'ws2tsw ', 'wstsw2 ', 'z_i    ' /)
+
+    CHARACTER (LEN=7), DIMENSION(dopr_norm_num) ::  dopr_norm_longnames =                          &
+         (/ 'wtheta0', 'w*2    ', 't*w2   ', 'w*3    ', 'w*2t*w ', 'w*t*w2 ', 'z_i    ' /)
+
+    CHARACTER (LEN=9), DIMENSION(300) ::  dopr_unit = 'unknown'
+
+    CHARACTER (LEN=7), DIMENSION(dopts_num) :: dopts_label =                                       &
+          (/ 'tnpt   ', 'x_     ', 'y_     ', 'z_     ', 'z_abs  ', 'u      ',                     &
+             'v      ', 'w      ', 'u"     ', 'v"     ', 'w"     ', 'npt_up ',                     &
+             'w_up   ', 'w_down ', 'radius ', 'r_min  ', 'r_max  ', 'npt_max',                     &
+             'npt_min', 'x*2    ', 'y*2    ', 'z*2    ', 'u*2    ', 'v*2    ',                     &
+             'w*2    ', 'u"2    ', 'v"2    ', 'w"2    ', 'npt*2  ' /)
+
+    CHARACTER (LEN=7), DIMENSION(dopts_num) :: dopts_unit =                                        &
+          (/ 'number ', 'm      ', 'm      ', 'm      ', 'm      ', 'm/s    ',                     &
+             'm/s    ', 'm/s    ', 'm/s    ', 'm/s    ', 'm/s    ', 'number ',                     &
+             'm/s    ', 'm/s    ', 'm      ', 'm      ', 'm      ', 'number ',                     &
+             'number ', 'm2     ', 'm2     ', 'm2     ', 'm2/s2  ', 'm2/s2  ',                     &
+             'm2/s2  ', 'm2/s2  ', 'm2/s2  ', 'm2/s2  ', 'number2' /)
+
+    CHARACTER (LEN=13), DIMENSION(dots_max) :: dots_label =                                        &
+          (/ 'E            ', 'E*           ', 'dt           ',                                    &
+             'us*          ', 'th*          ', 'umax         ',                                    &
+             'vmax         ', 'wmax         ', 'div_new      ',                                    &
+             'div_old      ', 'zi_wtheta    ', 'zi_theta     ',                                    &
+             'w*           ', 'w"theta"0    ', 'w"theta"     ',                                    &
+             'wtheta       ', 'theta(0)     ', 'theta(z_mo)  ',                                    &
+             'w"u"0        ', 'w"v"0        ', 'w"q"0        ',                                    &
+             'ol           ', 'q*           ', 'w"s"         ',                                    &
+             's*           ', 'ghf          ', 'qsws_liq     ',                                    &
+             'qsws_soil    ', 'qsws_veg     ', 'r_a          ',                                    &
+             'r_s          ',                                                                      &
+             'rad_net      ', 'rad_lw_in    ', 'rad_lw_out   ',                                    &
+             'rad_sw_in    ', 'rad_sw_out   ', 'rrtm_aldif   ',                                    &
+             'rrtm_aldir   ', 'rrtm_asdif   ', 'rrtm_asdir   ',                                    &
              ( 'unknown      ', i9 = 1, dots_max-40 ) /)
 
-    CHARACTER (LEN=13), DIMENSION(dots_max) :: dots_unit =                     &
-          (/ 'm2/s2        ', 'm2/s2        ', 's            ',                &
-             'm/s          ', 'K            ', 'm/s          ',                &
-             'm/s          ', 'm/s          ', 's-1          ',                &
-             's-1          ', 'm            ', 'm            ',                &
-             'm/s          ', 'K m/s        ', 'K m/s        ',                &
-             'K m/s        ', 'K            ', 'K            ',                &
-             'm2/s2        ', 'm2/s2        ', 'kg m/s       ',                &
-             'm            ', 'kg/kg        ', 'kg m/(kg s)  ',                &
-             'kg/kg        ', 'W/m2         ', 'W/m2         ',                &
-             'W/m2         ', 'W/m2         ', 's/m          ',                &
-             's/m          ',                                                  &
-             'W/m2         ', 'W/m2         ', 'W/m2         ',                &
-             'W/m2         ', 'W/m2         ', '             ',                &
-             '             ', '             ', '             ',                &
+    CHARACTER (LEN=13), DIMENSION(dots_max) :: dots_unit =                                         &
+          (/ 'm2/s2        ', 'm2/s2        ', 's            ',                                    &
+             'm/s          ', 'K            ', 'm/s          ',                                    &
+             'm/s          ', 'm/s          ', 's-1          ',                                    &
+             's-1          ', 'm            ', 'm            ',                                    &
+             'm/s          ', 'K m/s        ', 'K m/s        ',                                    &
+             'K m/s        ', 'K            ', 'K            ',                                    &
+             'm2/s2        ', 'm2/s2        ', 'kg m/s       ',                                    &
+             'm            ', 'kg/kg        ', 'kg m/(kg s)  ',                                    &
+             'kg/kg        ', 'W/m2         ', 'W/m2         ',                                    &
+             'W/m2         ', 'W/m2         ', 's/m          ',                                    &
+             's/m          ',                                                                      &
+             'W/m2         ', 'W/m2         ', 'W/m2         ',                                    &
+             'W/m2         ', 'W/m2         ', '             ',                                    &
+             '             ', '             ', '             ',                                    &
              ( 'unknown      ', i9 = 1, dots_max-40 ) /)
 
-    CHARACTER (LEN=16) :: heatflux_output_unit     !< unit for heatflux output
-    CHARACTER (LEN=16) :: waterflux_output_unit    !< unit for waterflux output
-    CHARACTER (LEN=16) :: momentumflux_output_unit !< unit for momentumflux output
-
-    CHARACTER (LEN=9), DIMENSION(300) ::  dopr_unit = 'unknown'
+    CHARACTER (LEN=20), DIMENSION(11) ::  netcdf_precision = ' '
 
     CHARACTER (LEN=7), DIMENSION(0:1,500) ::  do2d_unit, do3d_unit
@@ -260,77 +266,65 @@
 !             'not_used        ' /)
 
-    CHARACTER(LEN=20), DIMENSION(11) ::  netcdf_precision = ' '
-    CHARACTER(LEN=40) ::  netcdf_data_format_string
-
-    INTEGER(iwp) ::  id_dim_agtnum, id_dim_time_agt,                           &
-                     id_dim_time_fl, id_dim_time_pr,                           &
-                     id_dim_time_pts, id_dim_time_sp, id_dim_time_ts,          &
-                     id_dim_x_sp, id_dim_y_sp, id_dim_zu_sp, id_dim_zw_sp,     &
-                     id_set_agt, id_set_fl, id_set_pr, id_set_prt, id_set_pts, &
-                     id_set_sp, id_set_ts, id_var_agtnum, id_var_time_agt,     &
-                     id_var_time_fl, id_var_rnoa_agt, id_var_time_pr,          &
-                     id_var_time_pts, id_var_time_sp, id_var_time_ts,          &
-                     id_var_x_sp, id_var_y_sp, id_var_zu_sp, id_var_zw_sp,     &
+    INTEGER(iwp) ::  dofl_time_count
+
+    INTEGER(iwp) ::  id_dim_agtnum, id_dim_time_agt, id_dim_time_fl, id_dim_time_pr,               &
+                     id_dim_time_pts, id_dim_time_sp, id_dim_time_ts, id_dim_x_sp, id_dim_y_sp,    &
+                     id_dim_zu_sp, id_dim_zw_sp,                                                   &
+                     id_set_agt, id_set_fl, id_set_pr, id_set_prt, id_set_pts, id_set_sp,          &
+                     id_set_ts,                                                                    &
+                     id_var_agtnum, id_var_time_agt, id_var_time_fl, id_var_rnoa_agt,              &
+                     id_var_time_pr, id_var_time_pts, id_var_time_sp, id_var_time_ts, id_var_x_sp, &
+                     id_var_y_sp, id_var_zu_sp, id_var_zw_sp,                                      &
                      nc_stat
 
-
-    INTEGER(iwp), DIMENSION(0:1) ::  id_dim_time_xy, id_dim_time_xz, &
-                    id_dim_time_yz, id_dim_time_3d, id_dim_x_xy, id_dim_xu_xy, &
-                    id_dim_x_xz, id_dim_xu_xz, id_dim_x_yz, id_dim_xu_yz, &
-                    id_dim_x_3d, id_dim_xu_3d, id_dim_y_xy, id_dim_yv_xy, &
-                    id_dim_y_xz, id_dim_yv_xz, id_dim_y_yz, id_dim_yv_yz, &
-                    id_dim_y_3d, id_dim_yv_3d, id_dim_zs_xy, id_dim_zs_xz, &
-                    id_dim_zs_yz, id_dim_zs_3d, id_dim_zpc_3d, &
-                    id_dim_zu_xy, id_dim_zu1_xy, &
-                    id_dim_zu_xz, id_dim_zu_yz, id_dim_zu_3d, id_dim_zw_xy, &
-                    id_dim_zw_xz, id_dim_zw_yz, id_dim_zw_3d, id_set_xy, &
-                    id_set_xz, id_set_yz, id_set_3d, id_var_ind_x_yz, &
-                    id_var_ind_y_xz, id_var_ind_z_xy, id_var_time_xy, &
-                    id_var_time_xz, id_var_time_yz, id_var_time_3d, id_var_x_xy, &
-                    id_var_xu_xy, id_var_x_xz, id_var_xu_xz, id_var_x_yz, &
-                    id_var_xu_yz, id_var_x_3d, id_var_xu_3d, id_var_y_xy, &
-                    id_var_yv_xy, id_var_y_xz, id_var_yv_xz, id_var_y_yz, &
-                    id_var_yv_yz, id_var_y_3d, id_var_yv_3d, id_var_zs_xy, &
-                    id_var_zs_xz, id_var_zs_yz, id_var_zs_3d, id_var_zpc_3d, &
-                    id_var_zusi_xy, id_var_zusi_3d, id_var_zu_xy, id_var_zu1_xy, id_var_zu_xz, &
-                    id_var_zu_yz, id_var_zu_3d, id_var_zwwi_xy, id_var_zwwi_3d, &
-                    id_var_zw_xy, id_var_zw_xz, id_var_zw_yz, id_var_zw_3d
-
-    INTEGER(iwp), DIMENSION(0:2,0:1) ::  id_var_eutm_3d, id_var_nutm_3d, &
-                                         id_var_eutm_xy, id_var_nutm_xy, &
-                                         id_var_eutm_xz, id_var_nutm_xz, &
-                                         id_var_eutm_yz, id_var_nutm_yz
-
-    INTEGER(iwp), DIMENSION(0:2,0:1) ::  id_var_lat_3d, id_var_lon_3d, &
-                                         id_var_lat_xy, id_var_lon_xy, &
-                                         id_var_lat_xz, id_var_lon_xz, &
-                                         id_var_lat_yz, id_var_lon_yz
-
-    INTEGER ::  netcdf_data_format = 2  !< NetCDF3 64bit offset format
-    INTEGER ::  netcdf_deflate = 0      !< NetCDF compression, default: no
-                                        !< compression
-
-    INTEGER(iwp)                 ::  dofl_time_count
-    INTEGER(iwp), DIMENSION(10)  ::  id_var_dospx, id_var_dospy
-    INTEGER(iwp), DIMENSION(20)  ::  id_var_agt
-!    INTEGER(iwp), DIMENSION(20)  ::  id_var_prt
-    INTEGER(iwp), DIMENSION(11)  ::  nc_precision
+    INTEGER      ::  netcdf_data_format = 2  !< NetCDF3 64bit offset format
+    INTEGER      ::  netcdf_deflate = 0      !< NetCDF compression, default: no
+                                             !< compression
+
+    INTEGER(iwp), DIMENSION(20)            ::  id_var_agt
+    INTEGER(iwp), DIMENSION(10)            ::  id_var_dospx, id_var_dospy
     INTEGER(iwp), DIMENSION(dopr_norm_num) ::  id_var_norm_dopr
-
-    INTEGER(iwp), DIMENSION(fl_max) ::  id_dim_x_fl, id_dim_y_fl, id_dim_z_fl
-    INTEGER(iwp), DIMENSION(fl_max) ::  id_var_x_fl, id_var_y_fl, id_var_z_fl
-
-    CHARACTER (LEN=20), DIMENSION(fl_max*var_fl_max) :: dofl_label
-    CHARACTER (LEN=20), DIMENSION(fl_max*var_fl_max) :: dofl_unit
-    CHARACTER (LEN=20), DIMENSION(fl_max) :: dofl_dim_label_x
-    CHARACTER (LEN=20), DIMENSION(fl_max) :: dofl_dim_label_y
-    CHARACTER (LEN=20), DIMENSION(fl_max) :: dofl_dim_label_z
-
+!    INTEGER(iwp), DIMENSION(20)            ::  id_var_prt
+    INTEGER(iwp), DIMENSION(11)            ::  nc_precision
+
+    INTEGER(iwp), DIMENSION(fl_max)            ::  id_dim_x_fl, id_dim_y_fl, id_dim_z_fl
     INTEGER(iwp), DIMENSION(fl_max*var_fl_max) :: id_var_dofl
+    INTEGER(iwp), DIMENSION(fl_max)            ::  id_var_x_fl, id_var_y_fl, id_var_z_fl
+
+    INTEGER(iwp), DIMENSION(0:1) ::  id_dim_time_xy, id_dim_time_xz, id_dim_time_yz,               &
+                                     id_dim_time_3d, id_dim_x_xy, id_dim_xu_xy, id_dim_x_xz,       &
+                                     id_dim_xu_xz, id_dim_x_yz, id_dim_xu_yz, id_dim_x_3d,         &
+                                     id_dim_xu_3d, id_dim_y_xy, id_dim_yv_xy, id_dim_y_xz,         &
+                                     id_dim_yv_xz, id_dim_y_yz, id_dim_yv_yz, id_dim_y_3d,         &
+                                     id_dim_yv_3d, id_dim_zs_xy, id_dim_zs_xz, id_dim_zs_yz,       &
+                                     id_dim_zs_3d, id_dim_zpc_3d, id_dim_zu_xy, id_dim_zu1_xy,     &
+                                     id_dim_zu_xz, id_dim_zu_yz, id_dim_zu_3d, id_dim_zw_xy,       &
+                                     id_dim_zw_xz, id_dim_zw_yz, id_dim_zw_3d,                     &
+                                     id_set_xy, id_set_xz, id_set_yz, id_set_3d,                   &
+                                     id_var_ind_x_yz, id_var_ind_y_xz, id_var_ind_z_xy,            &
+                                     id_var_time_xy, id_var_time_xz, id_var_time_yz,               &
+                                     id_var_time_3d, id_var_x_xy, id_var_xu_xy, id_var_x_xz,       &
+                                     id_var_xu_xz, id_var_x_yz, id_var_xu_yz, id_var_x_3d,         &
+                                     id_var_xu_3d, id_var_y_xy, id_var_yv_xy, id_var_y_xz,         &
+                                     id_var_yv_xz, id_var_y_yz, id_var_yv_yz, id_var_y_3d,         &
+                                     id_var_yv_3d, id_var_zs_xy, id_var_zs_xz, id_var_zs_yz,       &
+                                     id_var_zs_3d, id_var_zpc_3d, id_var_zusi_xy, id_var_zusi_3d,  &
+                                     id_var_zu_xy, id_var_zu1_xy, id_var_zu_xz, id_var_zu_yz,      &
+                                     id_var_zu_3d, id_var_zwwi_xy, id_var_zwwi_3d, id_var_zw_xy,   &
+                                     id_var_zw_xz, id_var_zw_yz, id_var_zw_3d
+
+    INTEGER(iwp), DIMENSION(0:2,0:1) ::  id_var_eutm_3d, id_var_eutm_xy, id_var_eutm_xz,           &
+                                         id_var_eutm_yz,                                           &
+                                         id_var_nutm_3d, id_var_nutm_xy, id_var_nutm_xz,           &
+                                         id_var_nutm_yz
+
+    INTEGER(iwp), DIMENSION(0:2,0:1) ::  id_var_lat_3d, id_var_lat_xy, id_var_lat_xz,              &
+                                         id_var_lat_yz,                                            &
+                                         id_var_lon_3d, id_var_lon_xy, id_var_lon_xz, id_var_lon_yz
+
 
     INTEGER(iwp), DIMENSION(dopts_num,0:10) ::  id_var_dopts
     INTEGER(iwp), DIMENSION(0:1,500)        ::  id_var_do2d, id_var_do3d
-    INTEGER(iwp), DIMENSION(100,0:99)       ::  id_dim_z_pr, id_var_dopr, &
-                                                id_var_z_pr
+    INTEGER(iwp), DIMENSION(100,0:99)       ::  id_dim_z_pr, id_var_dopr, id_var_z_pr
     INTEGER(iwp), DIMENSION(dots_max,0:99)  ::  id_var_dots
 
